#ifndef _INCLUDE_GUARD_XIRCOM_CB_H_
#define _INCLUDE_GUARD_XIRCOM_CB_H_

static int xircom_probe(struct pci_dev *pdev, const struct pci_device_id *id);
static void xircom_remove(struct pci_dev *pdev);
static void xircom_interrupt(int irq, void *dev_instance, struct pt_regs *regs);
static int xircom_start_xmit(struct sk_buff *skb, struct net_device *dev);
static int xircom_open(struct net_device *dev);
static int xircom_close(struct net_device *dev);
static struct net_device_stats *xircom_get_stats(struct net_device *dev);




static void investigate_read_descriptor(struct net_device *dev,int number, int descnr, unsigned int bufferoffset);
static void investigate_write_descriptor(struct net_device *dev,int number, int descnr, unsigned int bufferoffset);


static void xircom_up(int number);
static void read_mac_address(int number);
static void tranceiver_voodoo(int number);
static void initialize_card(int number);
static void trigger_transmit(int number);
static void trigger_receive(int number);
static void setup_descriptors(int number);
static void remove_descriptors(int number);
static int link_status_changed(int number);
static int packed_is_received(int number);
static int packed_is_sent(int number);
static int transmit_active(int number);
static int receive_active(int number);
static int activate_receiver(int number);
static int deactivate_receiver(int number);
static int activate_transmitter(int number);
static int deactivate_transmitter(int number);
static int enable_transmit_interrupt(int number);
static int disable_transmit_interrupt(int number);
static int disable_receive_interrupt(int number);
static int enable_receive_interrupt(int number);
static int enable_link_interrupt(int number);
static int disable_link_interrupt(int number);
static int disable_all_interrupts(int number);
static int link_status(int number);
       
#endif
