#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 2 "aicasm_gram.y"
/*
 * Parser for the Aic7xxx SCSI Host adapter sequencer assembler.
 *
 * Copyright (c) 1997, 1998, 2000 Justin T. Gibbs.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer,
 *    without modification.
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * Alternatively, this software may be distributed under the terms of the
 * GNU Public License ("GPL").
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: //depot/src/aic7xxx/aicasm/aicasm_gram.y#6 $
 *
 * $FreeBSD: src/sys/dev/aic7xxx/aicasm/aicasm_gram.y,v 1.12 2000/10/31 18:44:32 gibbs Exp $
 */

#include <inttypes.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sysexits.h>

#include <sys/types.h>
#ifdef __linux__
#include "../queue.h"
#else
#include <sys/queue.h>
#endif

#include "aicasm.h"
#include "aicasm_symbol.h"
#include "aicasm_insformat.h"

int yylineno;
char *yyfilename;
static symbol_t *cur_symbol;
static symtype cur_symtype;
static symbol_t *accumulator;
static symbol_ref_t allones;
static symbol_ref_t allzeros;
static symbol_ref_t none;
static symbol_ref_t sindex;
static int instruction_ptr;
static int sram_or_scb_offset;
static int download_constant_count;
static int in_critical_section;

static void process_bitmask(int mask_type, symbol_t *sym, int mask);
static void initialize_symbol(symbol_t *symbol);
static void process_register(symbol_t **p_symbol);
static void format_1_instr(int opcode, symbol_ref_t *dest,
			   expression_t *immed, symbol_ref_t *src, int ret);
static void format_2_instr(int opcode, symbol_ref_t *dest,
			   expression_t *places, symbol_ref_t *src, int ret);
static void format_3_instr(int opcode, symbol_ref_t *src,
			   expression_t *immed, symbol_ref_t *address);
static void test_readable_symbol(symbol_t *symbol);
static void test_writable_symbol(symbol_t *symbol);
static void type_check(symbol_t *symbol, expression_t *expression, int and_op);
static void make_expression(expression_t *immed, int value);
static void add_conditional(symbol_t *symbol);
static int  is_download_const(expression_t *immed);

#define YYDEBUG 1
#define SRAM_SYMNAME "SRAM_BASE"
#define SCB_SYMNAME "SCB_BASE"
#line 89 "aicasm_gram.y"
typedef union {
	int		value;
	char		*str;
	symbol_t	*sym;
	symbol_ref_t	sym_ref;
	expression_t	expression;
} YYSTYPE;
#line 106 "y.tab.c"
#define T_REGISTER 257
#define T_CONST 258
#define T_DOWNLOAD 259
#define T_SCB 260
#define T_SRAM 261
#define T_ALIAS 262
#define T_SIZE 263
#define T_ADDRESS 264
#define T_ACCESS_MODE 265
#define T_MODE 266
#define T_BEGIN_CS 267
#define T_END_CS 268
#define T_BIT 269
#define T_MASK 270
#define T_NUMBER 271
#define T_PATH 272
#define T_CEXPR 273
#define T_EOF 274
#define T_INCLUDE 275
#define T_SHR 276
#define T_SHL 277
#define T_ROR 278
#define T_ROL 279
#define T_MVI 280
#define T_MOV 281
#define T_CLR 282
#define T_BMOV 283
#define T_JMP 284
#define T_JC 285
#define T_JNC 286
#define T_JE 287
#define T_JNE 288
#define T_JNZ 289
#define T_JZ 290
#define T_CALL 291
#define T_ADD 292
#define T_ADC 293
#define T_INC 294
#define T_DEC 295
#define T_STC 296
#define T_CLC 297
#define T_CMP 298
#define T_NOT 299
#define T_XOR 300
#define T_TEST 301
#define T_AND 302
#define T_OR 303
#define T_RET 304
#define T_NOP 305
#define T_ACCUM 306
#define T_ALLONES 307
#define T_ALLZEROS 308
#define T_NONE 309
#define T_SINDEX 310
#define T_A 311
#define T_SYMBOL 312
#define T_NL 313
#define T_IF 314
#define T_ELSE 315
#define T_ELSE_IF 316
#define T_ENDIF 317
#define UMINUS 318
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   16,   16,   27,   17,   29,   26,   28,   28,   30,   30,
   30,   30,   30,   30,   30,   30,   30,   30,   30,   31,
   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
    6,    6,    6,    6,    6,    6,    6,    6,    6,   18,
   18,   15,   15,   42,   44,   19,   45,   46,   20,   43,
   43,    1,    1,    1,    1,    3,    7,    8,    8,    4,
    5,    5,    9,    9,   22,   23,   21,    2,    2,    2,
    2,    2,    2,   24,   24,   24,   24,   10,   10,   10,
   10,   25,   25,   25,   25,   25,   25,   25,   25,   25,
   25,   25,   25,   25,   25,   25,   11,   11,   11,   11,
   25,   12,   12,   12,   12,   13,   13,   14,   14,   25,
   25,   25,   25,   25,   25,
};
short yylen[] = {                                         2,
    1,    2,    1,    2,    1,    2,    1,    2,    1,    2,
    1,    2,    1,    2,    1,    2,    1,    2,    1,    2,
    4,    4,    0,    3,    0,    5,    1,    2,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
    2,    2,    3,    3,    2,    1,    1,    1,    1,    1,
    3,    3,    3,    3,    3,    2,    2,    1,    1,    3,
    3,    1,    2,    0,    0,    7,    0,    0,    7,    1,
    2,    1,    4,    4,    1,    1,    1,    1,    1,    1,
    0,    2,    0,    1,    1,    1,    2,    1,    3,    3,
    1,    3,    3,    3,    4,    2,    1,    1,    1,    1,
    1,    7,    7,    5,    5,    3,    7,    3,    4,    8,
    6,    6,    5,    4,    3,    2,    1,    1,    1,    1,
    7,    1,    1,    1,    1,    1,    1,    1,    1,    3,
    7,    7,    7,    5,    5,
};
short yydefred[] = {                                      0,
   23,    0,    0,    0,   85,   86,    0,  118,  117,  120,
  119,    0,    0,    0,    0,  122,  123,  124,  125,  100,
  101,    0,    0,    0,    0,    0,    0,   99,    0,   98,
    0,    0,    0,    0,    0,    0,   97,    0,    0,    0,
    0,    1,    3,    5,    7,    9,   11,   13,   15,   17,
   19,    0,    0,   67,   64,    0,    0,   58,   75,    0,
    0,    0,    0,   76,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   84,    0,    0,    0,    0,
   80,    0,    0,    0,    0,  116,    0,   87,    0,    0,
   96,    2,    4,    6,    8,   10,   12,   14,   16,   18,
   20,    0,    0,    0,    0,    0,    0,   24,   61,   62,
    0,   60,    0,    0,    0,    0,    0,   59,   57,   56,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  108,    0,  106,    0,    0,
    0,    0,  115,   94,    0,    0,    0,    0,    0,    0,
    0,  130,   25,   63,    0,   68,   65,   21,   22,    0,
    0,   55,   79,    0,    0,    0,    0,   53,   54,    0,
    0,    0,  114,    0,   82,    0,    0,  109,    0,    0,
    0,    0,    0,    0,    0,   95,    0,    0,   89,   90,
   92,   93,    0,   40,    0,    0,   74,   73,    0,  135,
    0,  134,    0,  104,  105,    0,  128,  129,    0,  113,
  127,  126,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   46,   47,   48,   49,   50,    0,   27,   29,
   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,
   70,    0,    0,  112,  111,    0,    0,    0,    0,    0,
    0,    0,    0,   45,   41,   42,    0,    0,   26,   28,
   69,   71,   66,    0,  107,  133,  132,  131,  103,  102,
  121,   43,    0,  110,
};
short yydgoto[] = {                                      38,
   64,  106,   65,   71,  133,  164,   67,  165,   78,   39,
   40,   41,  213,  209,  112,   42,   43,   44,   45,   46,
   47,   48,   49,   50,   51,  241,   52,  228,  193,  229,
  230,  231,  232,  233,  234,  235,  236,  237,  238,  239,
  240,  114,  242,  196,  113,  195,
};
short yysindex[] = {                                    186,
    0, -277,  -80,  -71,    0,    0,   24,    0,    0,    0,
    0,  -36, -245, -245, -245,    0,    0,    0,    0,    0,
    0, -245, -245, -240, -253, -245, -245,    0, -245,    0,
 -245,    1, -241,   17, -195, -115,    0,  186, -245, -245,
  -45,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -220,  -43,    0,    0, -177, -153,    0,    0,   30,
  -35,  -35,  -35,    0,   76,    2, -185,   30,    0,   81,
 -185, -241,   84,   85,   85,    0, -241,   79, -245,   87,
    0,   91,   85,  103,  109,    0,   96,    0,   33, -116,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  114,  115,   40,   53,  102,   39,    0,    0,    0,
 -108,    0, -100, -100,  104,  131, -230,    0,    0,    0,
   -7,  -33,  -35,  -35,  -35,  -35,  -45, -245,  -45,  112,
 -245, -245, -241, -241,  113,    0,  129,    0,  -33, -241,
  -33,  -33,    0,    0,   54,  -33,  -35,  -93,  -91,  -90,
  -89,    0,    0,    0,  -88,    0,    0,    0,    0,   83,
   93,    0,    0,    2, -241,   10,   73,    0,    0,  125,
 -241,  126,    0,  143,    0,  130,  132,    0,  -33, -180,
  133, -187,    2, -185,   85,    0,   85,   36,    0,    0,
    0,    0,   78,    0, -220, -220,    0,    0,  134,    0,
  135,    0,  -35,    0,    0, -241,    0,    0,  -45,    0,
    0,    0,  -45,  -45, -241, -241, -241, -124,  -81,  -70,
 -117, -112,    0,    0,    0,    0,    0,  -95,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -105, -103,    0,    0, -241,  138,  139,  142,  146,
  147,  149,  159,    0,    0,    0,  -69,  -35,    0,    0,
    0,    0,    0,  160,    0,    0,    0,    0,    0,    0,
    0,    0,    2,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  161,  161,    0,    0,    0,    0,    0,
    0,    0,  161,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -27,
    0,    0,    0,    0,    0,   45,    0,  -30,   32,    0,
    0,  161,    0,  -44,  -44,    0,  161,    0,    0,    0,
    0,    0,  -44,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  162,  163,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  161,  161,    0,    0,    0,    0,    0,  161,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    6,  161,   18,  -38,    0,    0,    0,
  161,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   29,    0,  -44,    0,  -44,  -44,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  161,    0,    0,    0,    0,
    0,    0,    0,    0,  161,  161,  161,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  161,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   92,    0,
};
short yygindex[] = {                                      0,
   13, -104,  100,   20,  -51,    7, -114,  -85,  212,    0,
    0,  -34,    0,    0,    0,  185,  191,  192,  195,  196,
  201,  202,  203,  204,  205,  -39,    0,    0,    0,   16,
   -2,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   66,    0,    0,    0,
};
#define YYTABLESIZE 501
short yytable[] = {                                      52,
  105,  111,   52,   63,   63,   52,   63,   91,   61,   61,
   59,   61,  108,   72,   81,   59,   72,   59,   66,  261,
   52,  263,  170,  134,  172,   69,   79,  184,   72,  259,
  124,  140,  127,  162,   53,  125,  129,  126,   81,  124,
  160,   81,   54,   85,  125,   82,  126,  124,   84,   78,
   76,   55,  125,  180,  126,  182,  185,   57,   51,   86,
  187,   51,   76,   76,   78,   59,   68,  119,  120,  121,
   59,   68,   78,  124,   88,   76,   51,   89,  125,  132,
  126,  161,  148,   56,  149,   52,   52,   78,  246,   62,
   62,  107,   62,  206,  115,  150,   59,  151,   16,   17,
   18,  211,  212,   77,  248,   19,  207,  208,  249,  250,
  156,  157,   70,   72,   73,  125,  123,  126,  116,  122,
  117,   74,   75,   77,  128,  123,   83,  131,  132,  166,
  167,  168,  169,  215,  139,  216,  217,  136,  102,  103,
   81,   51,   51,   81,   81,  138,  141,  171,  183,  214,
  174,  175,  142,  188,  143,  144,  145,  146,  147,  123,
  152,  153,  154,  155,  159,  158,  218,  219,  155,  220,
  173,  178,  179,  221,  222,  197,  186,  189,  137,  190,
  191,  192,  194,  200,  202,  198,  203,  254,  204,  255,
  205,  210,  244,  245,  257,  256,  265,  266,   90,  258,
  267,  272,  262,  262,  268,  269,  107,  270,  107,   66,
  223,  224,  225,  226,  227,  109,   44,  271,  274,   83,
   88,   91,   92,   52,   52,   52,   52,  110,   93,   94,
   52,   52,   95,   96,   58,   58,   80,   58,   97,   98,
   99,  100,  101,  260,   87,   52,   52,   52,   52,   52,
   52,   52,   52,   72,   72,   72,   59,   59,   59,   81,
   72,  243,    0,   59,  273,   52,  104,   52,   52,   52,
   52,   52,    0,   72,   59,   60,  118,  163,  118,   51,
   51,   51,   51,  130,    0,    0,   51,   51,  135,    0,
    0,    0,   78,   78,   78,   78,    0,    0,    0,    0,
    0,   51,   51,   51,   51,   51,   51,   51,   51,   78,
   37,    0,   77,   77,   77,   80,   80,   80,    0,   77,
    0,   51,   80,   51,   51,   51,   51,   51,   77,   77,
   77,    0,   78,    0,    0,   77,    0,    0,    0,  218,
  219,  155,  220,    0,  176,  177,  221,  222,   77,    0,
    0,  181,    0,   44,   44,   44,   44,    0,    0,    0,
   44,   44,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  199,    0,    0,    0,
    0,    0,  201,  223,  224,  225,  226,  227,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   44,   44,   44,
   44,   44,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  247,    0,    0,
    0,    0,    0,    0,    0,    0,  251,  252,  253,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    1,    2,    0,    3,    4,    0,    0,    0,
    0,    0,    5,    6,    0,    0,    0,  264,    0,    0,
    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
   17,   18,    0,    0,    0,    0,   19,   20,   21,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
   33,    0,    0,    0,    0,    0,    0,   34,    0,   35,
   36,
};
short yycheck[] = {                                      38,
   46,   45,   41,   40,   40,   44,   40,  123,   45,   45,
   38,   45,   52,   44,   59,   43,   44,   45,   12,  125,
   59,  125,  127,   75,  129,   13,  280,  142,   59,  125,
   38,   83,   67,   41,  312,   43,   71,   45,   26,   38,
  271,   29,  123,   31,   43,   26,   45,   38,   29,   44,
  304,  123,   43,  139,   45,  141,  142,   34,   41,   59,
  146,   44,  304,  304,   59,  311,  312,   61,   62,   63,
  311,  312,   44,   38,   58,   44,   59,  273,   43,   44,
   45,  312,   43,   60,   45,  124,  125,   59,  203,  126,
  126,  312,  126,  179,  272,   43,  124,   45,  284,  285,
  286,  289,  290,   59,  209,  291,  287,  288,  213,  214,
  113,  114,   13,   14,   15,   43,  124,   45,  272,   44,
   91,   22,   23,   24,   44,  124,   27,   44,   44,  123,
  124,  125,  126,  185,   44,  187,  188,   59,   39,   40,
  128,  124,  125,  131,  132,   59,   44,  128,  142,  184,
  131,  132,   44,  147,   59,  123,  273,   44,   44,  124,
   59,  123,  271,  264,   34,   62,  262,  263,  264,  265,
   59,   59,   44,  269,  270,   93,  123,  271,   79,  271,
  271,  271,  271,   59,   59,   93,   44,  312,   59,  271,
   59,   59,   59,   59,  312,  266,   59,   59,  314,  312,
   59,  271,  242,  243,   59,   59,  312,   59,  312,  203,
  306,  307,  308,  309,  310,  259,  125,   59,   59,   59,
   59,   59,   38,  262,  263,  264,  265,  271,   38,   38,
  269,  270,   38,   38,  271,  271,   25,  271,   38,   38,
   38,   38,   38,  228,   33,  284,  285,  286,  287,  288,
  289,  290,  291,  284,  285,  286,  284,  285,  286,  304,
  291,  196,   -1,  291,  258,  304,  312,  306,  307,  308,
  309,  310,   -1,  304,  311,  312,  312,  311,  312,  262,
  263,  264,  265,   72,   -1,   -1,  269,  270,   77,   -1,
   -1,   -1,  287,  288,  289,  290,   -1,   -1,   -1,   -1,
   -1,  284,  285,  286,  287,  288,  289,  290,  291,  304,
  125,   -1,  284,  285,  286,  284,  285,  286,   -1,  291,
   -1,  304,  291,  306,  307,  308,  309,  310,  284,  285,
  286,   -1,  304,   -1,   -1,  291,   -1,   -1,   -1,  262,
  263,  264,  265,   -1,  133,  134,  269,  270,  304,   -1,
   -1,  140,   -1,  262,  263,  264,  265,   -1,   -1,   -1,
  269,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  165,   -1,   -1,   -1,
   -1,   -1,  171,  306,  307,  308,  309,  310,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  306,  307,  308,
  309,  310,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  206,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  215,  216,  217,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,  258,   -1,  260,  261,   -1,   -1,   -1,
   -1,   -1,  267,  268,   -1,   -1,   -1,  246,   -1,   -1,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,   -1,   -1,   -1,   -1,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,   -1,   -1,   -1,   -1,   -1,   -1,  312,   -1,  314,
  315,
};
#define YYFINAL 38
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 318
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'\"'",0,0,0,"'&'",0,"'('","')'",0,"'+'","','","'-'","'.'",0,0,0,0,0,0,0,0,0,0,
0,"':'","';'","'<'",0,"'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"T_REGISTER","T_CONST","T_DOWNLOAD",
"T_SCB","T_SRAM","T_ALIAS","T_SIZE","T_ADDRESS","T_ACCESS_MODE","T_MODE",
"T_BEGIN_CS","T_END_CS","T_BIT","T_MASK","T_NUMBER","T_PATH","T_CEXPR","T_EOF",
"T_INCLUDE","T_SHR","T_SHL","T_ROR","T_ROL","T_MVI","T_MOV","T_CLR","T_BMOV",
"T_JMP","T_JC","T_JNC","T_JE","T_JNE","T_JNZ","T_JZ","T_CALL","T_ADD","T_ADC",
"T_INC","T_DEC","T_STC","T_CLC","T_CMP","T_NOT","T_XOR","T_TEST","T_AND","T_OR",
"T_RET","T_NOP","T_ACCUM","T_ALLONES","T_ALLZEROS","T_NONE","T_SINDEX","T_A",
"T_SYMBOL","T_NL","T_IF","T_ELSE","T_ELSE_IF","T_ENDIF","UMINUS",
};
char *yyrule[] = {
"$accept : program",
"program : include",
"program : program include",
"program : register",
"program : program register",
"program : constant",
"program : program constant",
"program : scratch_ram",
"program : program scratch_ram",
"program : scb",
"program : program scb",
"program : label",
"program : program label",
"program : critical_section_start",
"program : program critical_section_start",
"program : critical_section_end",
"program : program critical_section_end",
"program : conditional",
"program : program conditional",
"program : code",
"program : program code",
"include : T_INCLUDE '<' T_PATH '>'",
"include : T_INCLUDE '\"' T_PATH '\"'",
"$$1 :",
"register : T_REGISTER $$1 reg_definition",
"$$2 :",
"reg_definition : T_SYMBOL '{' $$2 reg_attribute_list '}'",
"reg_attribute_list : reg_attribute",
"reg_attribute_list : reg_attribute_list reg_attribute",
"reg_attribute : reg_address",
"reg_attribute : size",
"reg_attribute : access_mode",
"reg_attribute : bit_defn",
"reg_attribute : mask_defn",
"reg_attribute : alias",
"reg_attribute : accumulator",
"reg_attribute : allones",
"reg_attribute : allzeros",
"reg_attribute : none",
"reg_attribute : sindex",
"reg_address : T_ADDRESS T_NUMBER",
"size : T_SIZE T_NUMBER",
"access_mode : T_ACCESS_MODE T_MODE",
"bit_defn : T_BIT T_SYMBOL T_NUMBER",
"mask_defn : T_MASK T_SYMBOL expression",
"alias : T_ALIAS T_SYMBOL",
"accumulator : T_ACCUM",
"allones : T_ALLONES",
"allzeros : T_ALLZEROS",
"none : T_NONE",
"sindex : T_SINDEX",
"expression : expression '|' expression",
"expression : expression '&' expression",
"expression : expression '+' expression",
"expression : expression '-' expression",
"expression : '(' expression ')'",
"expression : '~' expression",
"expression : '-' expression",
"expression : T_NUMBER",
"expression : T_SYMBOL",
"constant : T_CONST T_SYMBOL numerical_value",
"constant : T_CONST T_SYMBOL T_DOWNLOAD",
"numerical_value : T_NUMBER",
"numerical_value : '-' T_NUMBER",
"$$3 :",
"$$4 :",
"scratch_ram : T_SRAM '{' $$3 reg_address $$4 scb_or_sram_reg_list '}'",
"$$5 :",
"$$6 :",
"scb : T_SCB '{' $$5 reg_address $$6 scb_or_sram_reg_list '}'",
"scb_or_sram_reg_list : reg_definition",
"scb_or_sram_reg_list : scb_or_sram_reg_list reg_definition",
"reg_symbol : T_SYMBOL",
"reg_symbol : T_SYMBOL '[' T_SYMBOL ']'",
"reg_symbol : T_SYMBOL '[' T_NUMBER ']'",
"reg_symbol : T_A",
"destination : reg_symbol",
"immediate : expression",
"immediate_or_a : expression",
"immediate_or_a : T_A",
"source : reg_symbol",
"opt_source :",
"opt_source : ',' source",
"ret :",
"ret : T_RET",
"critical_section_start : T_BEGIN_CS",
"critical_section_end : T_END_CS",
"label : T_SYMBOL ':'",
"address : T_SYMBOL",
"address : T_SYMBOL '+' T_NUMBER",
"address : T_SYMBOL '-' T_NUMBER",
"address : '.'",
"address : '.' '+' T_NUMBER",
"address : '.' '-' T_NUMBER",
"conditional : T_IF T_CEXPR '{'",
"conditional : T_ELSE T_IF T_CEXPR '{'",
"conditional : T_ELSE '{'",
"conditional : '}'",
"f1_opcode : T_AND",
"f1_opcode : T_XOR",
"f1_opcode : T_ADD",
"f1_opcode : T_ADC",
"code : f1_opcode destination ',' immediate_or_a opt_source ret ';'",
"code : T_OR reg_symbol ',' immediate_or_a opt_source ret ';'",
"code : T_INC destination opt_source ret ';'",
"code : T_DEC destination opt_source ret ';'",
"code : T_CLC ret ';'",
"code : T_CLC T_MVI destination ',' immediate_or_a ret ';'",
"code : T_STC ret ';'",
"code : T_STC destination ret ';'",
"code : T_BMOV destination ',' source ',' immediate ret ';'",
"code : T_MOV destination ',' source ret ';'",
"code : T_MVI destination ',' immediate_or_a ret ';'",
"code : T_NOT destination opt_source ret ';'",
"code : T_CLR destination ret ';'",
"code : T_NOP ret ';'",
"code : T_RET ';'",
"f2_opcode : T_SHL",
"f2_opcode : T_SHR",
"f2_opcode : T_ROL",
"f2_opcode : T_ROR",
"code : f2_opcode destination ',' expression opt_source ret ';'",
"jmp_jc_jnc_call : T_JMP",
"jmp_jc_jnc_call : T_JC",
"jmp_jc_jnc_call : T_JNC",
"jmp_jc_jnc_call : T_CALL",
"jz_jnz : T_JZ",
"jz_jnz : T_JNZ",
"je_jne : T_JE",
"je_jne : T_JNE",
"code : jmp_jc_jnc_call address ';'",
"code : T_OR reg_symbol ',' immediate jmp_jc_jnc_call address ';'",
"code : T_TEST source ',' immediate_or_a jz_jnz address ';'",
"code : T_CMP source ',' immediate_or_a je_jne address ';'",
"code : T_MOV source jmp_jc_jnc_call address ';'",
"code : T_MVI immediate jmp_jc_jnc_call address ';'",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 1043 "aicasm_gram.y"

static void
process_bitmask(int mask_type, symbol_t *sym, int mask)
{
	/*
	 * Add the current register to its
	 * symbol list, if it already exists,
	 * warn if we are setting it to a
	 * different value, or in the bit to
	 * the "allowed bits" of this register.
	 */
	if (sym->type == UNINITIALIZED) {
		sym->type = mask_type;
		initialize_symbol(sym);
		if (mask_type == BIT) {
			if (mask == 0) {
				stop("Bitmask with no bits set", EX_DATAERR);
				/* NOTREACHED */
			}
			if ((mask & ~(0x01 << (ffs(mask) - 1))) != 0) {
				stop("Bitmask with more than one bit set",
				     EX_DATAERR);
				/* NOTREACHED */
			}
		}
		sym->info.minfo->mask = mask;
	} else if (sym->type != mask_type) {
		stop("Bit definition mirrors a definition of the same "
		     " name, but a different type", EX_DATAERR);
		/* NOTREACHED */
	} else if (mask != sym->info.minfo->mask) {
		stop("Bitmask redefined with a conflicting value", EX_DATAERR);
		/* NOTREACHED */
	}
	/* Fail if this symbol is already listed */
	if (symlist_search(&(sym->info.minfo->symrefs),
			   cur_symbol->name) != NULL) {
		stop("Bitmask defined multiple times for register", EX_DATAERR);
		/* NOTREACHED */
	}
	symlist_add(&(sym->info.minfo->symrefs), cur_symbol,
		    SYMLIST_INSERT_HEAD);
	cur_symbol->info.rinfo->valid_bitmask |= mask;
	cur_symbol->info.rinfo->typecheck_masks = TRUE;
}

static void
initialize_symbol(symbol_t *symbol)
{
	switch (symbol->type) {
        case UNINITIALIZED:
		stop("Call to initialize_symbol with type field unset",
		     EX_SOFTWARE);
		/* NOTREACHED */
		break;
        case REGISTER:
        case SRAMLOC:
        case SCBLOC:
		symbol->info.rinfo =
		    (struct reg_info *)malloc(sizeof(struct reg_info));
		if (symbol->info.rinfo == NULL) {
			stop("Can't create register info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.rinfo, 0,
		       sizeof(struct reg_info));
		break;
        case ALIAS:
		symbol->info.ainfo =
		    (struct alias_info *)malloc(sizeof(struct alias_info));
		if (symbol->info.ainfo == NULL) {
			stop("Can't create alias info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.ainfo, 0,
		       sizeof(struct alias_info));
		break;
        case MASK:
        case BIT:
		symbol->info.minfo =
		    (struct mask_info *)malloc(sizeof(struct mask_info));
		if (symbol->info.minfo == NULL) {
			stop("Can't create bitmask info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.minfo, 0, sizeof(struct mask_info));
		SLIST_INIT(&(symbol->info.minfo->symrefs));
		break;
        case CONST:
        case DOWNLOAD_CONST:
		symbol->info.cinfo =
		    (struct const_info *)malloc(sizeof(struct const_info));
		if (symbol->info.cinfo == NULL) {
			stop("Can't create alias info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.cinfo, 0,
		       sizeof(struct const_info));
		break;
	case LABEL:
		symbol->info.linfo =
		    (struct label_info *)malloc(sizeof(struct label_info));
		if (symbol->info.linfo == NULL) {
			stop("Can't create label info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.linfo, 0,
		       sizeof(struct label_info));
		break;
	case CONDITIONAL:
		symbol->info.condinfo =
		    (struct cond_info *)malloc(sizeof(struct cond_info));
		if (symbol->info.condinfo == NULL) {
			stop("Can't create conditional info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.condinfo, 0,
		       sizeof(struct cond_info));
		break;
	default:
		stop("Call to initialize_symbol with invalid symbol type",
		     EX_SOFTWARE);
		/* NOTREACHED */
		break;
	}
}

static void
process_register(symbol_t **p_symbol)
{
	char buf[255];
	symbol_t *symbol = *p_symbol;

	if (symbol->type == UNINITIALIZED) {
		snprintf(buf, sizeof(buf), "Undefined register %s",
			 symbol->name);
		stop(buf, EX_DATAERR);
		/* NOTREACHED */
	} else if (symbol->type == ALIAS) {
		*p_symbol = symbol->info.ainfo->parent;
	} else if ((symbol->type != REGISTER)
		&& (symbol->type != SCBLOC)
		&& (symbol->type != SRAMLOC)) {
		snprintf(buf, sizeof(buf),
			 "Specified symbol %s is not a register",
			 symbol->name);
		stop(buf, EX_DATAERR);
	}
}

static void
format_1_instr(int opcode, symbol_ref_t *dest, expression_t *immed,
	       symbol_ref_t *src, int ret)
{
	struct instruction *instr;
	struct ins_format1 *f1_instr;

	if (src->symbol == NULL)
		src = dest;

	/* Test register permissions */
	test_writable_symbol(dest->symbol);
	test_readable_symbol(src->symbol);

	/* Ensure that immediate makes sense for this destination */
	type_check(dest->symbol, immed, opcode);

	/* Allocate sequencer space for the instruction and fill it out */
	instr = seq_alloc();
	f1_instr = &instr->format.format1;
	f1_instr->ret = ret ? 1 : 0;
	f1_instr->opcode = opcode;
	f1_instr->destination = dest->symbol->info.rinfo->address
			      + dest->offset;
	f1_instr->source = src->symbol->info.rinfo->address
			 + src->offset;
	f1_instr->immediate = immed->value;

	if (is_download_const(immed))
		f1_instr->parity = 1;

	symlist_free(&immed->referenced_syms);
	instruction_ptr++;
}

static void
format_2_instr(int opcode, symbol_ref_t *dest, expression_t *places,
	       symbol_ref_t *src, int ret)
{
	struct instruction *instr;
	struct ins_format2 *f2_instr;
	uint8_t shift_control;

	if (src->symbol == NULL)
		src = dest;

	/* Test register permissions */
	test_writable_symbol(dest->symbol);
	test_readable_symbol(src->symbol);

	/* Allocate sequencer space for the instruction and fill it out */
	instr = seq_alloc();
	f2_instr = &instr->format.format2;
	f2_instr->ret = ret ? 1 : 0;
	f2_instr->opcode = AIC_OP_ROL;
	f2_instr->destination = dest->symbol->info.rinfo->address
			      + dest->offset;
	f2_instr->source = src->symbol->info.rinfo->address
			 + src->offset;
	if (places->value > 8 || places->value <= 0) {
		stop("illegal shift value", EX_DATAERR);
		/* NOTREACHED */
	}
	switch (opcode) {
	case AIC_OP_SHL:
		if (places->value == 8)
			shift_control = 0xf0;
		else
			shift_control = (places->value << 4) | places->value;
		break;
	case AIC_OP_SHR:
		if (places->value == 8) {
			shift_control = 0xf8;
		} else {
			shift_control = (places->value << 4)
				      | (8 - places->value)
				      | 0x08;
		}
		break;
	case AIC_OP_ROL:
		shift_control = places->value & 0x7;
		break;
	case AIC_OP_ROR:
		shift_control = (8 - places->value) | 0x08;
		break;
	default:
		shift_control = 0; /* Quiet Compiler */
		stop("Invalid shift operation specified", EX_SOFTWARE);
		/* NOTREACHED */
		break;
	};
	f2_instr->shift_control = shift_control;
	symlist_free(&places->referenced_syms);
	instruction_ptr++;
}

static void
format_3_instr(int opcode, symbol_ref_t *src,
	       expression_t *immed, symbol_ref_t *address)
{
	struct instruction *instr;
	struct ins_format3 *f3_instr;
	int addr;

	/* Test register permissions */
	test_readable_symbol(src->symbol);

	/* Ensure that immediate makes sense for this source */
	type_check(src->symbol, immed, opcode);

	/* Allocate sequencer space for the instruction and fill it out */
	instr = seq_alloc();
	f3_instr = &instr->format.format3;
	if (address->symbol == NULL) {
		/* 'dot' referrence.  Use the current instruction pointer */
		addr = instruction_ptr + address->offset;
	} else if (address->symbol->type == UNINITIALIZED) {
		/* forward reference */
		addr = address->offset;
		instr->patch_label = address->symbol;
	} else
		addr = address->symbol->info.linfo->address + address->offset;
	f3_instr->opcode = opcode;
	f3_instr->address = addr;
	f3_instr->source = src->symbol->info.rinfo->address
			 + src->offset;
	f3_instr->immediate = immed->value;

	if (is_download_const(immed))
		f3_instr->parity = 1;

	symlist_free(&immed->referenced_syms);
	instruction_ptr++;
}

static void
test_readable_symbol(symbol_t *symbol)
{
	if (symbol->info.rinfo->mode == WO) {
		stop("Write Only register specified as source",
		     EX_DATAERR);
		/* NOTREACHED */
	}
}

static void
test_writable_symbol(symbol_t *symbol)
{
	if (symbol->info.rinfo->mode == RO) {
		stop("Read Only register specified as destination",
		     EX_DATAERR);
		/* NOTREACHED */
	}
}

static void
type_check(symbol_t *symbol, expression_t *expression, int opcode)
{
	symbol_node_t *node;
	int and_op;
	char buf[255];

	and_op = FALSE;
	if (opcode == AIC_OP_AND || opcode == AIC_OP_JNZ || AIC_OP_JZ)
		and_op = TRUE;

	/*
	 * Make sure that we aren't attempting to write something
	 * that hasn't been defined.  If this is an and operation,
	 * this is a mask, so "undefined" bits are okay.
	 */
	if (and_op == FALSE
	 && (expression->value & ~symbol->info.rinfo->valid_bitmask) != 0) {
		snprintf(buf, sizeof(buf),
			 "Invalid bit(s) 0x%x in immediate written to %s",
			 expression->value & ~symbol->info.rinfo->valid_bitmask,
			 symbol->name);
		stop(buf, EX_DATAERR);
		/* NOTREACHED */
	}

	/*
	 * Now make sure that all of the symbols referenced by the
	 * expression are defined for this register.
	 */
	if(symbol->info.rinfo->typecheck_masks != FALSE) {
		for(node = expression->referenced_syms.slh_first;
		    node != NULL;
		    node = node->links.sle_next) {
			if ((node->symbol->type == MASK
			  || node->symbol->type == BIT)
			 && symlist_search(&node->symbol->info.minfo->symrefs,
					   symbol->name) == NULL) {
				snprintf(buf, sizeof(buf),
					 "Invalid bit or mask %s "
					 "for register %s",
					 node->symbol->name, symbol->name);
				stop(buf, EX_DATAERR);
				/* NOTREACHED */
			}
		}
	}
}

static void
make_expression(expression_t *immed, int value)
{
	SLIST_INIT(&immed->referenced_syms);
	immed->value = value & 0xff;
}

static void
add_conditional(symbol_t *symbol)
{
	static int numfuncs;

	if (numfuncs == 0) {
		/* add a special conditional, "0" */
		symbol_t *false_func;

		false_func = symtable_get("0");
		if (false_func->type != UNINITIALIZED) {
			stop("Conditional expression '0' "
			     "conflicts with a symbol", EX_DATAERR);
			/* NOTREACHED */
		}
		false_func->type = CONDITIONAL;
		initialize_symbol(false_func);
		false_func->info.condinfo->func_num = numfuncs++;
		symlist_add(&patch_functions, false_func, SYMLIST_INSERT_HEAD);
	}

	/* This condition has occurred before */
	if (symbol->type == CONDITIONAL)
		return;

	if (symbol->type != UNINITIALIZED) {
		stop("Conditional expression conflicts with a symbol",
		     EX_DATAERR);
		/* NOTREACHED */
	}

	symbol->type = CONDITIONAL;
	initialize_symbol(symbol);
	symbol->info.condinfo->func_num = numfuncs++;
	symlist_add(&patch_functions, symbol, SYMLIST_INSERT_HEAD);
}

void
yyerror(const char *string)
{
	stop(string, EX_DATAERR);
}

static int
is_download_const(expression_t *immed)
{
	if ((immed->referenced_syms.slh_first != NULL)
	 && (immed->referenced_syms.slh_first->symbol->type == DOWNLOAD_CONST))
		return (TRUE);

	return (FALSE);
}
#line 1011 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 21:
#line 205 "aicasm_gram.y"
{ include_file(yyvsp[-1].str, BRACKETED_INCLUDE); }
break;
case 22:
#line 207 "aicasm_gram.y"
{ include_file(yyvsp[-1].str, QUOTED_INCLUDE); }
break;
case 23:
#line 211 "aicasm_gram.y"
{ cur_symtype = REGISTER; }
break;
case 25:
#line 216 "aicasm_gram.y"
{
			if (yyvsp[-1].sym->type != UNINITIALIZED) {
				stop("Register multiply defined", EX_DATAERR);
				/* NOTREACHED */
			}
			cur_symbol = yyvsp[-1].sym; 
			cur_symbol->type = cur_symtype;
			initialize_symbol(cur_symbol);
		}
break;
case 26:
#line 227 "aicasm_gram.y"
{                    
			/*
			 * Default to allowing everything in for registers
			 * with no bit or mask definitions.
			 */
			if (cur_symbol->info.rinfo->valid_bitmask == 0)
				cur_symbol->info.rinfo->valid_bitmask = 0xFF;

			if (cur_symbol->info.rinfo->size == 0)
				cur_symbol->info.rinfo->size = 1;

			/*
			 * This might be useful for registers too.
			 */
			if (cur_symbol->type != REGISTER) {
				if (cur_symbol->info.rinfo->address == 0)
					cur_symbol->info.rinfo->address =
					    sram_or_scb_offset;
				sram_or_scb_offset +=
				    cur_symbol->info.rinfo->size;
			}
			cur_symbol = NULL;
		}
break;
case 40:
#line 273 "aicasm_gram.y"
{
		cur_symbol->info.rinfo->address = yyvsp[0].value;
	}
break;
case 41:
#line 280 "aicasm_gram.y"
{
		cur_symbol->info.rinfo->size = yyvsp[0].value;
	}
break;
case 42:
#line 287 "aicasm_gram.y"
{
		cur_symbol->info.rinfo->mode = yyvsp[0].value;
	}
break;
case 43:
#line 294 "aicasm_gram.y"
{
		process_bitmask(BIT, yyvsp[-1].sym, yyvsp[0].value);
	}
break;
case 44:
#line 301 "aicasm_gram.y"
{
		process_bitmask(MASK, yyvsp[-1].sym, yyvsp[0].expression.value);
	}
break;
case 45:
#line 308 "aicasm_gram.y"
{
		if (yyvsp[0].sym->type != UNINITIALIZED) {
			stop("Re-definition of register alias",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		yyvsp[0].sym->type = ALIAS;
		initialize_symbol(yyvsp[0].sym);
		yyvsp[0].sym->info.ainfo->parent = cur_symbol;
	}
break;
case 46:
#line 322 "aicasm_gram.y"
{
		if (accumulator != NULL) {
			stop("Only one accumulator definition allowed",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		accumulator = cur_symbol;
	}
break;
case 47:
#line 334 "aicasm_gram.y"
{
		if (allones.symbol != NULL) {
			stop("Only one definition of allones allowed",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		allones.symbol = cur_symbol;
	}
break;
case 48:
#line 346 "aicasm_gram.y"
{
		if (allzeros.symbol != NULL) {
			stop("Only one definition of allzeros allowed",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		allzeros.symbol = cur_symbol;
	}
break;
case 49:
#line 358 "aicasm_gram.y"
{
		if (none.symbol != NULL) {
			stop("Only one definition of none allowed",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		none.symbol = cur_symbol;
	}
break;
case 50:
#line 370 "aicasm_gram.y"
{
		if (sindex.symbol != NULL) {
			stop("Only one definition of sindex allowed",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		sindex.symbol = cur_symbol;
	}
break;
case 51:
#line 382 "aicasm_gram.y"
{
		 yyval.expression.value = yyvsp[-2].expression.value | yyvsp[0].expression.value;
		 symlist_merge(&yyval.expression.referenced_syms,
			       &yyvsp[-2].expression.referenced_syms,
			       &yyvsp[0].expression.referenced_syms);
	}
break;
case 52:
#line 389 "aicasm_gram.y"
{
		yyval.expression.value = yyvsp[-2].expression.value & yyvsp[0].expression.value;
		symlist_merge(&yyval.expression.referenced_syms,
			       &yyvsp[-2].expression.referenced_syms,
			       &yyvsp[0].expression.referenced_syms);
	}
break;
case 53:
#line 396 "aicasm_gram.y"
{
		yyval.expression.value = yyvsp[-2].expression.value + yyvsp[0].expression.value;
		symlist_merge(&yyval.expression.referenced_syms,
			       &yyvsp[-2].expression.referenced_syms,
			       &yyvsp[0].expression.referenced_syms);
	}
break;
case 54:
#line 403 "aicasm_gram.y"
{
		yyval.expression.value = yyvsp[-2].expression.value - yyvsp[0].expression.value;
		symlist_merge(&(yyval.expression.referenced_syms),
			       &(yyvsp[-2].expression.referenced_syms),
			       &(yyvsp[0].expression.referenced_syms));
	}
break;
case 55:
#line 410 "aicasm_gram.y"
{
		yyval.expression = yyvsp[-1].expression;
	}
break;
case 56:
#line 414 "aicasm_gram.y"
{
		yyval.expression = yyvsp[0].expression;
		yyval.expression.value = (~yyval.expression.value) & 0xFF;
	}
break;
case 57:
#line 419 "aicasm_gram.y"
{
		yyval.expression = yyvsp[0].expression;
		yyval.expression.value = -yyval.expression.value;
	}
break;
case 58:
#line 424 "aicasm_gram.y"
{
		yyval.expression.value = yyvsp[0].value;
		SLIST_INIT(&yyval.expression.referenced_syms);
	}
break;
case 59:
#line 429 "aicasm_gram.y"
{
		symbol_t *symbol;

		symbol = yyvsp[0].sym;
		switch (symbol->type) {
		case ALIAS:
			symbol = yyvsp[0].sym->info.ainfo->parent;
		case REGISTER:
		case SCBLOC:
		case SRAMLOC:
			yyval.expression.value = symbol->info.rinfo->address;
			break;
		case MASK:
		case BIT:
			yyval.expression.value = symbol->info.minfo->mask;
			break;
		case DOWNLOAD_CONST:
		case CONST:
			yyval.expression.value = symbol->info.cinfo->value;
			break;
		case UNINITIALIZED:
		default:
		{
			char buf[255];

			snprintf(buf, sizeof(buf),
				 "Undefined symbol %s referenced",
				 symbol->name);
			stop(buf, EX_DATAERR);
			/* NOTREACHED */
			break;
		}
		}
		SLIST_INIT(&yyval.expression.referenced_syms);
		symlist_add(&yyval.expression.referenced_syms, symbol, SYMLIST_INSERT_HEAD);
	}
break;
case 60:
#line 469 "aicasm_gram.y"
{
		if (yyvsp[-1].sym->type != UNINITIALIZED) {
			stop("Re-definition of symbol as a constant",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		yyvsp[-1].sym->type = CONST;
		initialize_symbol(yyvsp[-1].sym);
		yyvsp[-1].sym->info.cinfo->value = yyvsp[0].value;
		yyvsp[-1].sym->info.cinfo->define = yyvsp[-2].value;
	}
break;
case 61:
#line 481 "aicasm_gram.y"
{
		if (yyvsp[-2].value) {
			stop("Invalid downloaded constant declaration",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		if (yyvsp[-1].sym->type != UNINITIALIZED) {
			stop("Re-definition of symbol as a downloaded constant",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		yyvsp[-1].sym->type = DOWNLOAD_CONST;
		initialize_symbol(yyvsp[-1].sym);
		yyvsp[-1].sym->info.cinfo->value = download_constant_count++;
		yyvsp[-1].sym->info.cinfo->define = FALSE;
	}
break;
case 62:
#line 501 "aicasm_gram.y"
{
		yyval.value = yyvsp[0].value;
	}
break;
case 63:
#line 505 "aicasm_gram.y"
{
		yyval.value = -yyvsp[0].value;
	}
break;
case 64:
#line 512 "aicasm_gram.y"
{
			cur_symbol = symtable_get(SRAM_SYMNAME);
			cur_symtype = SRAMLOC;
			if (cur_symbol->type != UNINITIALIZED) {
				stop("Only one SRAM definition allowed",
				     EX_DATAERR);
				/* NOTREACHED */
			}
			cur_symbol->type = SRAMLOC;
			initialize_symbol(cur_symbol);
		}
break;
case 65:
#line 524 "aicasm_gram.y"
{
			sram_or_scb_offset = cur_symbol->info.rinfo->address;
		}
break;
case 66:
#line 529 "aicasm_gram.y"
{
			cur_symbol = NULL;
		}
break;
case 67:
#line 536 "aicasm_gram.y"
{
			cur_symbol = symtable_get(SCB_SYMNAME);
			cur_symtype = SCBLOC;
			if (cur_symbol->type != UNINITIALIZED) {
				stop("Only one SRAM definition allowed",
				     EX_SOFTWARE);
				/* NOTREACHED */
			}
			cur_symbol->type = SCBLOC;
			initialize_symbol(cur_symbol);
			/* 64 bytes of SCB space */
			cur_symbol->info.rinfo->size = 64;
		}
break;
case 68:
#line 550 "aicasm_gram.y"
{
			sram_or_scb_offset = cur_symbol->info.rinfo->address;
		}
break;
case 69:
#line 555 "aicasm_gram.y"
{
			cur_symbol = NULL;
		}
break;
case 72:
#line 567 "aicasm_gram.y"
{
		process_register(&yyvsp[0].sym);
		yyval.sym_ref.symbol = yyvsp[0].sym;
		yyval.sym_ref.offset = 0;
	}
break;
case 73:
#line 573 "aicasm_gram.y"
{
		process_register(&yyvsp[-3].sym);
		if (yyvsp[-1].sym->type != CONST) {
			stop("register offset must be a constant", EX_DATAERR);
			/* NOTREACHED */
		}
		if ((yyvsp[-1].sym->info.cinfo->value + 1) > yyvsp[-3].sym->info.rinfo->size) {
			stop("Accessing offset beyond range of register",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		yyval.sym_ref.symbol = yyvsp[-3].sym;
		yyval.sym_ref.offset = yyvsp[-1].sym->info.cinfo->value;
	}
break;
case 74:
#line 588 "aicasm_gram.y"
{
		process_register(&yyvsp[-3].sym);
		if ((yyvsp[-1].value + 1) > yyvsp[-3].sym->info.rinfo->size) {
			stop("Accessing offset beyond range of register",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		yyval.sym_ref.symbol = yyvsp[-3].sym;
		yyval.sym_ref.offset = yyvsp[-1].value;
	}
break;
case 75:
#line 599 "aicasm_gram.y"
{
		if (accumulator == NULL) {
			stop("No accumulator has been defined", EX_DATAERR);
			/* NOTREACHED */
		}
		yyval.sym_ref.symbol = accumulator;
		yyval.sym_ref.offset = 0;
	}
break;
case 76:
#line 611 "aicasm_gram.y"
{
		test_writable_symbol(yyvsp[0].sym_ref.symbol);
		yyval.sym_ref = yyvsp[0].sym_ref;
	}
break;
case 77:
#line 619 "aicasm_gram.y"
{ yyval.expression = yyvsp[0].expression; }
break;
case 78:
#line 624 "aicasm_gram.y"
{
		yyval.expression = yyvsp[0].expression;
	}
break;
case 79:
#line 628 "aicasm_gram.y"
{
		SLIST_INIT(&yyval.expression.referenced_syms);
		yyval.expression.value = 0;
	}
break;
case 80:
#line 636 "aicasm_gram.y"
{
		test_readable_symbol(yyvsp[0].sym_ref.symbol);
		yyval.sym_ref = yyvsp[0].sym_ref;
	}
break;
case 81:
#line 643 "aicasm_gram.y"
{
		yyval.sym_ref.symbol = NULL;
		yyval.sym_ref.offset = 0;
	}
break;
case 82:
#line 648 "aicasm_gram.y"
{ yyval.sym_ref = yyvsp[0].sym_ref; }
break;
case 83:
#line 652 "aicasm_gram.y"
{ yyval.value = 0; }
break;
case 84:
#line 654 "aicasm_gram.y"
{ yyval.value = 1; }
break;
case 85:
#line 659 "aicasm_gram.y"
{
		critical_section_t *cs;

		if (in_critical_section != FALSE) {
			stop("Critical Section within Critical Section",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		cs = cs_alloc();
		cs->begin_addr = instruction_ptr;
		in_critical_section = TRUE;
	}
break;
case 86:
#line 674 "aicasm_gram.y"
{
		critical_section_t *cs;

		if (in_critical_section == FALSE) {
			stop("Unballanced 'end_cs'", EX_DATAERR);
			/* NOTREACHED */
		}
		cs = TAILQ_LAST(&cs_tailq, cs_tailq);
		cs->end_addr = instruction_ptr;
		in_critical_section = FALSE;
	}
break;
case 87:
#line 688 "aicasm_gram.y"
{
		if (yyvsp[-1].sym->type != UNINITIALIZED) {
			stop("Program label multiply defined", EX_DATAERR);
			/* NOTREACHED */
		}
		yyvsp[-1].sym->type = LABEL;
		initialize_symbol(yyvsp[-1].sym);
		yyvsp[-1].sym->info.linfo->address = instruction_ptr;
	}
break;
case 88:
#line 701 "aicasm_gram.y"
{
		yyval.sym_ref.symbol = yyvsp[0].sym;
		yyval.sym_ref.offset = 0;
	}
break;
case 89:
#line 706 "aicasm_gram.y"
{
		yyval.sym_ref.symbol = yyvsp[-2].sym;
		yyval.sym_ref.offset = yyvsp[0].value;
	}
break;
case 90:
#line 711 "aicasm_gram.y"
{
		yyval.sym_ref.symbol = yyvsp[-2].sym;
		yyval.sym_ref.offset = -yyvsp[0].value;
	}
break;
case 91:
#line 716 "aicasm_gram.y"
{
		yyval.sym_ref.symbol = NULL;
		yyval.sym_ref.offset = 0;
	}
break;
case 92:
#line 721 "aicasm_gram.y"
{
		yyval.sym_ref.symbol = NULL;
		yyval.sym_ref.offset = yyvsp[0].value;
	}
break;
case 93:
#line 726 "aicasm_gram.y"
{
		yyval.sym_ref.symbol = NULL;
		yyval.sym_ref.offset = -yyvsp[0].value;
	}
break;
case 94:
#line 734 "aicasm_gram.y"
{
		scope_t *new_scope;

		add_conditional(yyvsp[-1].sym);
		new_scope = scope_alloc();
		new_scope->type = SCOPE_IF;
		new_scope->begin_addr = instruction_ptr;
		new_scope->func_num = yyvsp[-1].sym->info.condinfo->func_num;
	}
break;
case 95:
#line 744 "aicasm_gram.y"
{
		scope_t *new_scope;
		scope_t *scope_context;
		scope_t *last_scope;

		/*
		 * Ensure that the previous scope is either an
		 * if or and else if.
		 */
		scope_context = SLIST_FIRST(&scope_stack);
		last_scope = TAILQ_LAST(&scope_context->inner_scope,
					scope_tailq);
		if (last_scope == NULL
		 || last_scope->type == T_ELSE) {

			stop("'else if' without leading 'if'", EX_DATAERR);
			/* NOTREACHED */
		}
		add_conditional(yyvsp[-1].sym);
		new_scope = scope_alloc();
		new_scope->type = SCOPE_ELSE_IF;
		new_scope->begin_addr = instruction_ptr;
		new_scope->func_num = yyvsp[-1].sym->info.condinfo->func_num;
	}
break;
case 96:
#line 769 "aicasm_gram.y"
{
		scope_t *new_scope;
		scope_t *scope_context;
		scope_t *last_scope;

		/*
		 * Ensure that the previous scope is either an
		 * if or and else if.
		 */
		scope_context = SLIST_FIRST(&scope_stack);
		last_scope = TAILQ_LAST(&scope_context->inner_scope,
					scope_tailq);
		if (last_scope == NULL
		 || last_scope->type == SCOPE_ELSE) {

			stop("'else' without leading 'if'", EX_DATAERR);
			/* NOTREACHED */
		}
		new_scope = scope_alloc();
		new_scope->type = SCOPE_ELSE;
		new_scope->begin_addr = instruction_ptr;
	}
break;
case 97:
#line 795 "aicasm_gram.y"
{
		scope_t *scope_context;

		scope_context = SLIST_FIRST(&scope_stack);
		if (scope_context->type == SCOPE_ROOT) {
			stop("Unexpected '}' encountered", EX_DATAERR);
			/* NOTREACHED */
		}

		scope_context->end_addr = instruction_ptr;

		/* Pop the scope */
		SLIST_REMOVE_HEAD(&scope_stack, scope_stack_links);

		process_scope(scope_context);

		if (SLIST_FIRST(&scope_stack) == NULL) {
			stop("Unexpected '}' encountered", EX_DATAERR);
			/* NOTREACHED */
		}
	}
break;
case 98:
#line 819 "aicasm_gram.y"
{ yyval.value = AIC_OP_AND; }
break;
case 99:
#line 820 "aicasm_gram.y"
{ yyval.value = AIC_OP_XOR; }
break;
case 100:
#line 821 "aicasm_gram.y"
{ yyval.value = AIC_OP_ADD; }
break;
case 101:
#line 822 "aicasm_gram.y"
{ yyval.value = AIC_OP_ADC; }
break;
case 102:
#line 827 "aicasm_gram.y"
{
		format_1_instr(yyvsp[-6].value, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 103:
#line 834 "aicasm_gram.y"
{
		format_1_instr(AIC_OP_OR, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 104:
#line 841 "aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 1);
		format_1_instr(AIC_OP_ADD, &yyvsp[-3].sym_ref, &immed, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 105:
#line 851 "aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, -1);
		format_1_instr(AIC_OP_ADD, &yyvsp[-3].sym_ref, &immed, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 106:
#line 861 "aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, -1);
		format_1_instr(AIC_OP_ADD, &none, &immed, &allzeros, yyvsp[-1].value);
	}
break;
case 107:
#line 868 "aicasm_gram.y"
{
		format_1_instr(AIC_OP_ADD, &yyvsp[-4].sym_ref, &yyvsp[-2].expression, &allzeros, yyvsp[-1].value);
	}
break;
case 108:
#line 875 "aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 1);
		format_1_instr(AIC_OP_ADD, &none, &immed, &allones, yyvsp[-1].value);
	}
break;
case 109:
#line 882 "aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 1);
		format_1_instr(AIC_OP_ADD, &yyvsp[-2].sym_ref, &immed, &allones, yyvsp[-1].value);
	}
break;
case 110:
#line 892 "aicasm_gram.y"
{
		format_1_instr(AIC_OP_BMOV, &yyvsp[-6].sym_ref, &yyvsp[-2].expression, &yyvsp[-4].sym_ref, yyvsp[-1].value);
	}
break;
case 111:
#line 899 "aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 1);
		format_1_instr(AIC_OP_BMOV, &yyvsp[-4].sym_ref, &immed, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 112:
#line 909 "aicasm_gram.y"
{
		format_1_instr(AIC_OP_OR, &yyvsp[-4].sym_ref, &yyvsp[-2].expression, &allzeros, yyvsp[-1].value);
	}
break;
case 113:
#line 916 "aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 0xff);
		format_1_instr(AIC_OP_XOR, &yyvsp[-3].sym_ref, &immed, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 114:
#line 926 "aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 0xff);
		format_1_instr(AIC_OP_AND, &yyvsp[-2].sym_ref, &immed, &allzeros, yyvsp[-1].value);
	}
break;
case 115:
#line 936 "aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 0xff);
		format_1_instr(AIC_OP_AND, &none, &immed, &allzeros, yyvsp[-1].value);
	}
break;
case 116:
#line 946 "aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 0xff);
		format_1_instr(AIC_OP_AND, &none, &immed, &allzeros, TRUE);
	}
break;
case 117:
#line 964 "aicasm_gram.y"
{ yyval.value = AIC_OP_SHL; }
break;
case 118:
#line 965 "aicasm_gram.y"
{ yyval.value = AIC_OP_SHR; }
break;
case 119:
#line 966 "aicasm_gram.y"
{ yyval.value = AIC_OP_ROL; }
break;
case 120:
#line 967 "aicasm_gram.y"
{ yyval.value = AIC_OP_ROR; }
break;
case 121:
#line 972 "aicasm_gram.y"
{
		format_2_instr(yyvsp[-6].value, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 122:
#line 978 "aicasm_gram.y"
{ yyval.value = AIC_OP_JMP; }
break;
case 123:
#line 979 "aicasm_gram.y"
{ yyval.value = AIC_OP_JC; }
break;
case 124:
#line 980 "aicasm_gram.y"
{ yyval.value = AIC_OP_JNC; }
break;
case 125:
#line 981 "aicasm_gram.y"
{ yyval.value = AIC_OP_CALL; }
break;
case 126:
#line 985 "aicasm_gram.y"
{ yyval.value = AIC_OP_JZ; }
break;
case 127:
#line 986 "aicasm_gram.y"
{ yyval.value = AIC_OP_JNZ; }
break;
case 128:
#line 990 "aicasm_gram.y"
{ yyval.value = AIC_OP_JE; }
break;
case 129:
#line 991 "aicasm_gram.y"
{ yyval.value = AIC_OP_JNE; }
break;
case 130:
#line 996 "aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 0);
		format_3_instr(yyvsp[-2].value, &sindex, &immed, &yyvsp[-1].sym_ref);
	}
break;
case 131:
#line 1006 "aicasm_gram.y"
{
		format_3_instr(yyvsp[-2].value, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-1].sym_ref);
	}
break;
case 132:
#line 1013 "aicasm_gram.y"
{
		format_3_instr(yyvsp[-2].value, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-1].sym_ref);
	}
break;
case 133:
#line 1020 "aicasm_gram.y"
{
		format_3_instr(yyvsp[-2].value, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-1].sym_ref);
	}
break;
case 134:
#line 1027 "aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 0);
		format_3_instr(yyvsp[-2].value, &yyvsp[-3].sym_ref, &immed, &yyvsp[-1].sym_ref);
	}
break;
case 135:
#line 1037 "aicasm_gram.y"
{
		format_3_instr(yyvsp[-2].value, &allzeros, &yyvsp[-3].expression, &yyvsp[-1].sym_ref);
	}
break;
#line 2003 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
